"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _awsSdk = require("aws-sdk");

var _bluebird = _interopRequireDefault(require("bluebird"));

/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */
_awsSdk.config.setPromisesDependency(_bluebird.default);

class Connector {
  constructor({
    debug,
    tableName,
    timeout = process.env.DYNAMODB_TIMEOUT || process.env.TIMEOUT || 1000
  }) {
    this.debug = debug;
    this.tableName = tableName ||
    /* istanbul ignore next */
    'undefined';
    this.db = new _awsSdk.DynamoDB.DocumentClient({
      httpOptions: {
        timeout // agent: sslAgent,

      },
      logger: {
        log:
        /* istanbul ignore next */
        msg => this.debug(msg)
      },
      convertEmptyValues: true
    });
  }

  update(inputParams) {
    const params = {
      TableName: this.tableName,
      ...inputParams
    };
    return this.db.update(params).promise().tap(this.debug).tapCatch(this.debug).catch(
    /* istanbul ignore next */
    err => {
      if (err.code === 'ConditionalCheckFailedException') {
        return {};
      }

      return _bluebird.default.reject(err);
    });
  }

}

var _default = Connector;
exports.default = _default;